#ifndef _brdinfo_H
#define _brdinfo_H

#define MAX_UFPGA_BOARDS 8
#define UFPGA_MAX_BAR  6



typedef union u_UFPGA_ADDR
{	
	unsigned long   addr32; // 32 bit BAR address
	struct {
		unsigned long lowpart; // low 32 bit of 64 bit address
		unsigned long highpart; // high 32 bit of 64 bit address
	} addr64; // 64 bit BAR address
}UFPGA_ADDR, *PUFPGA_ADDR;

typedef struct s_UFPGA_IO
{
	UFPGA_ADDR     base; //BAR base address
	unsigned long  len; // length of BAR
}UFPGA_IO, *PUFPGA_IO;

// BAR address
typedef struct s_UFPGA_DEVINFO
{
	UFPGA_IO      memWindows[UFPGA_MAX_BAR]; // array of BARs addresses
	int			  numBARs; // total number of active BARs
	int			  index; // index of this board
	ULONG			  VID; // vendor ID
	ULONG			  DID; // device ID	
}UFPGA_DEVINFO, *PUFPGA_DEVINFO;


typedef struct s_UFPGA_BOARDINFO
{
	UFPGA_DEVINFO UfpgaDevInfo[MAX_UFPGA_BOARDS];
}UFPGA_ALL_BOARDINFO;

#endif