/*******************************************************************************
**	File:			ctipci_hw.h
**	Author:			Hasan Jamal
**	
**
**	Description:
**		Board hardware, PLD Settings etc.
**
**	Copyright (c) 2012, CTI, Connect Tech Inc. All Rights Reserved.
**
**	THIS IS THE UNPUBLISHED PROPRIETARY SOURCE CODE OF CONNECT TECH INC.
**	The copyright notice above does not evidence any actual or intended
**	publication of such source code.
**
**	This module contains Proprietary Information of Connect Tech, Inc
**	and should be treated as Confidential.
******************************************************************************/


#ifndef _CTIPCI_hw_h
#define _CTIPCI_hw_h

	//	General purpose macro for generating Bit field masks
	#define	FIELD_MASK(size,lowest_bit)		((0xFFFF >> (16-(size))) << (lowest_bit))		//	'size' in bits

	#define	CTI_VENDOR_ID	(0x12c4)	// CTI's  Vendor ID
	#define PLX_VENDOR_ID	(0x10B5)
	
	// Supported Device IDs
	#define DEV_ID_FCG001	(0x9056)
	#define	DEV_ID_FDG001	(0x1300)
	#define	DEV_ID_FDG002	(0x1301)
	#define	DEV_ID_FDG101	(0x1380)
	#define	DEV_ID_CCG901	(0x1390)
	#define DEV_ID_CEG001	(0x1500)
	#define DEV_ID_DAG001	(0x1200)
	#define DEV_ID_DAG002	(0x1200)
	#define DEV_ID_DAG003	(0x1201)
	#define DEV_ID_DAG004	(0x1201)
	#define DEV_ID_DAG005	(0x1201)
	#define DEV_ID_DAG103	(0x1210)
	#define DEV_ID_ADG043	(0x1400)
			
#endif
