/************************************************************
**	File:	sample.cpp
**	Author:	
**			HJ
**		      
**	Description:
**		
**		sample app for UFPGA driver
**      
**         
**	THIS IS THE UNPUBLISHED PROPRIETARY SOURCE CODE OF CONNECT TECH INC.
**	The copyright notice above does not evidence any actual or intended
**	publication of such source code.
**      
**	This module contains Proprietary Information of Connect Tech, Inc
**	and should be treated as Confidential.
************************************************************/
////////////////////////////////////////
//(c) 2016 Connect Tech Inc. Corporation 
//All Rights Reserved.
//
//Connect Tech Inc. hereby grants the User of this Connect Tech Inc. 
//product-specific UFPGA sample application a non-exclusive, nontransferable license 
//to use in accordance with the term set forth below.  
//Before using the sample, the User should read the following use 
//restrictions.  If the User does not accept these terms, the sample 
//should not be used. or downloaded.
//The User is granted this limited license to use this sample for 
//User's end product that includes the Connect Tech Inc. UFPGA, 
//and is not granted rights to sell, loan, rent, lease or license the 
//sample, in whole or in part, or in modified form to anyone other 
//than User.  User may modify the sample to suit its specific 
//applications but rights to derivative works and such modifications 
//shall belong to Connect Tech Inc..
//
//The sample is provided on an "AS IS" basis and Connect Tech Inc. makes absolutely 
//no warranty with respect to performance or the information contained 
//therein.  Connect Tech Inc. DISCLAIMS AND USER WAIVES ALL WARRANTIES, EXPRESS OR 
//IMPLIED, INCLUDING WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A 
//PARTICULAR PURPOSE.  The entire risk as to sample application quality and 
//performance is with the User.  ACCORDINGLY, IN NO EVENT SHALL Connect Tech Inc. 
//BE LIABLE FOR ANY DAMAGES, WHETHER IN CONTRACT OR TORT, INCLUDING 
//ANY LOST PROFITS OR OTHER INCIDENTAL, CONSEQUENTIAL, EXEMPLARY, OR 
//PUNITIVE DAMAGES ARISING OUT OF THE USE OR APPLICATION OF THE sample application.  
//Further, Connect Tech Inc. reserves the right to make changes to the sample application without 
//notice to improve reliability, function or design.  Connect Tech Inc. does not 
//convey any license under patent rights or any other intellectual 
//property rights, including those of third parties.
//
//
//////////////////////////////////////////////////////

#include "stdafx.h"
#include <windows.h>
#include <winioctl.h>
#include <strsafe.h>
#include "boardinfo.h"
#include "ctifpgalib.h"

#define DEFAULT_OFFSET 0x00
#define BAR 0

#define DATA_ARRAY_SIZE 100


void PrintWin32ErrorCode(DWORD errNo) 
{ 
    // Retrieve the system error message for the last-error code
    LPVOID lpMsgBuf;
    LPVOID lpDisplayBuf;   

    FormatMessage(
        FORMAT_MESSAGE_ALLOCATE_BUFFER | 
        FORMAT_MESSAGE_FROM_SYSTEM |
        FORMAT_MESSAGE_IGNORE_INSERTS,
        NULL,
        errNo,
        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
        (LPTSTR) &lpMsgBuf,
        0, NULL );

    // Display the error message and exit the process

    lpDisplayBuf = (LPVOID)LocalAlloc(LMEM_ZEROINIT, (lstrlen((LPCTSTR)lpMsgBuf))+ 40*sizeof(TCHAR)); 
    StringCchPrintf((LPTSTR)lpDisplayBuf, 
        LocalSize(lpDisplayBuf) / sizeof(TCHAR),
        TEXT("Failed with error %d: %s"), 
        errNo, lpMsgBuf);     
	 printf_s("%s\n",lpDisplayBuf);

    LocalFree(lpMsgBuf);
    LocalFree(lpDisplayBuf);    
}


int __cdecl main(int argc, char* argv[])
{
	DWORD err;	
	CHAR data[DATA_ARRAY_SIZE];	
	UFPGA_ALL_BOARDINFO AllBoardInfo={0};
	CtiUfpgaBoard brdInfo;
	int i, j, reqSize=DATA_ARRAY_SIZE;	
	UCHAR index = 0;
	

	if(argc > 1)
	{
		reqSize = atoi(argv[1]);
		if(reqSize > DATA_ARRAY_SIZE)
			reqSize = DATA_ARRAY_SIZE;
	}		

	err = CTIFindBoard (&AllBoardInfo);  
	if(err)
	{
		if(err <= 0xffff)
			PrintWin32ErrorCode(err);
		else
			printf("CTIFindBoard failed error 0x%x\n",err);
		return 0;
	}
	for(j=0; j<MAX_UFPGA_BOARDS; j++)
	{
		if(!AllBoardInfo.UfpgaDevInfo[j].VID)
			break;
		printf("Board %d VID 0x%x DID 0x%X index %d Number of Bars %d\n",j, AllBoardInfo.UfpgaDevInfo[j].VID, AllBoardInfo.UfpgaDevInfo[j].DID, 
			AllBoardInfo.UfpgaDevInfo[j].index, AllBoardInfo.UfpgaDevInfo[j].numBARs);
		for(i=0; i<AllBoardInfo.UfpgaDevInfo[j].numBARs; i++)
			printf("BAR %d Address 0x%X Length 0x%X\n",i, AllBoardInfo.UfpgaDevInfo[j].memWindows[i].base.addr32, AllBoardInfo.UfpgaDevInfo[j].memWindows[i].len);

		if(AllBoardInfo.UfpgaDevInfo[j].VID == 0x12c4) 
			index = AllBoardInfo.UfpgaDevInfo[j].index; // if you have same type of multiple board in the computer then decide based on BAR resources also
	}

	err = CTIConnectBoard(&brdInfo, index);
	if(err)
	{
		if(err <= 0xffff)
			PrintWin32ErrorCode(err);
		else
			printf("CTIConnectBoard failed error 0x%x\n",err);
		return 0;
	}
	
	
	for(i=0;i<DATA_ARRAY_SIZE;i++)
		data[i]=i+1;

	
	err = CTIFPGAWrByte(&brdInfo, BAR, DEFAULT_OFFSET, data[0]);
	if(err)
	{
		if(err <= 0xffff)
			PrintWin32ErrorCode(err);
		else
			printf("CTIFPGAWrByte failed error 0x%x\n",err);
		return 0;
	}
	
	err = CTIFPGAWrWord(&brdInfo, BAR, DEFAULT_OFFSET + 1, *((unsigned short *)&data[1]));
	if(err)
	{
		if(err <= 0xffff)
			PrintWin32ErrorCode(err);
		else
			printf("CTIFPGAWrWord failed error 0x%x\n",err);
		return 0;
	}	
	
	err = CTIFPGAWrDword(&brdInfo, BAR, DEFAULT_OFFSET  + 3, *((unsigned int *)&data[3]));
	if(err)
	{
		if(err <= 0xffff)
			PrintWin32ErrorCode(err);
		else
			printf("CTIFPGAWrDword failed error 0x%x\n",err);
		return 0;
	}
		
	err = CTIFPGAWrMem(&brdInfo, BAR, DEFAULT_OFFSET + 7, reqSize - 7, &data[7]);
	if(err)
	{
		if(err <= 0xffff)
			PrintWin32ErrorCode(err);
		else
			printf("CTIFPGAWrMem failed error 0x%x\n",err);
		return 0;
	}
	
	for(i=0;i<DATA_ARRAY_SIZE;i++)
		data[i]=0;
		
	err = CTIFPGARdByte(&brdInfo, BAR, DEFAULT_OFFSET, (UCHAR *)&data[0]);
	if(err)
	{
		if(err <= 0xffff)
			PrintWin32ErrorCode(err);
		else
			printf("CTIFPGARdByte failed error 0x%x\n",err);
		return 0;
	}
	
	err = CTIFPGARdWord(&brdInfo, BAR, DEFAULT_OFFSET + 1,  (USHORT *)(&data[1]));
	if(err)
	{
		if(err <= 0xffff)
			PrintWin32ErrorCode(err);
		else
			printf("CTIFPGARdWord failed error 0x%x\n",err);
		return 0;
	}
	
	err = CTIFPGARdDword(&brdInfo, BAR, DEFAULT_OFFSET + 3, (unsigned int *) (&data[3]));
	if(err)
	{
		if(err <= 0xffff)
			PrintWin32ErrorCode(err);
		else
			printf("CTIFPGARdDword failed error 0x%x\n",err);
		return 0;
	}
		
	err = CTIFPGARdMem(&brdInfo, BAR, DEFAULT_OFFSET + 7, reqSize - 7,  &data[7]);
	if(err)
	{
		if(err <= 0xffff)
			PrintWin32ErrorCode(err);
		else
			printf("CTIFPGARdMem failed error 0x%x\n",err);
		return 0;
	}
		
	for(i=0;i<reqSize;i++)
	{
		if(i+1 != data[i])
			printf("data written does not match with read");
		printf("i %d val %d\n",i, data[i]);
	}

	for(i=0;i<DATA_ARRAY_SIZE;i++)
		data[i]=0;

	err = CTIFPGARdCfgDword(&brdInfo, 0, (unsigned int *) (&data[0]));
	if(err)
	{
		if(err <= 0xffff)
			PrintWin32ErrorCode(err);
		else
			printf("CTIFPGARdCfgDword failed error 0x%x\n",err);
		return 0;
	}
	printf("DIDVID %x\n", *((unsigned int *) &data[0]));
	for(i=0;i<DATA_ARRAY_SIZE;i++)
		data[i]=0;
	
	err = CTIFPGARdCfgMem(&brdInfo, 0, 4, data);
	if(err)
	{
		if(err <= 0xffff)
			PrintWin32ErrorCode(err);
		else
			printf("CTIFPGARdCfgMem failed error 0x%x\n",err);
		return 0;
	}
	printf("DIDVID %x\n", *((unsigned int *) &data[0]));
	
	CTIDisconnectBoard(&brdInfo);

	return 0;
}

